"""
@author: luojunhui
"""
from quart import Blueprint, jsonify, request

from applications.deal import SearchDeal2, ProcessDeal, RecallDeal

my_blueprint = Blueprint('LongArticles', __name__)


def Routes(mysql_client):
    """
    路由代码
    """

    @my_blueprint.route('/healthcheck')
    def healthcheck():
        """
        Hello World Test
        :return:
        """
        return jsonify({'message': 'Hello, World!'})

    @my_blueprint.route('/search_videos', methods=['POST'])
    async def search_videos_from_the_web():
        """
        从web 搜索视频并且存储到票圈的视频库中
        :return:
        """
        params = await request.get_json()
        SD = SearchDeal2(params=params, mysql_client=mysql_client)
        result = await SD.deal()
        return jsonify(result)

    @my_blueprint.route('/recall_videos', methods=['POST'])
    async def recall_results():
        """
        获取视频分享卡片
        :return:
        """
        data = await request.get_json()
        trace_id = data['traceId']
        minigram_type = data['miniprogramUseType']
        RD = RecallDeal(trace_id=trace_id, mini_program_type=minigram_type, mysql_client=mysql_client)
        response = await RD.deal()
        return jsonify(response)

    @my_blueprint.route("/task")
    async def schedule_task():
        """
        执行代码
        :return:
        """
        PD = ProcessDeal(mysql_client=mysql_client)
        await PD.deal()
        return jsonify({"success": "true"})

    return my_blueprint
